package com.tsf.demo.service;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@FeignClient(name = "middleman")
public interface MiddlemanFeignService {
    // middleman 接受http请求，并返回
    @RequestMapping(value = "/http/echo/{param}", method = RequestMethod.GET)
    String httpEcho(@PathVariable("param") String param);

    // middleman 接受http请求，调用远程dubbo服务并返回
    @RequestMapping(value = "/dubbo/echo/{param}", method = RequestMethod.GET)
    String dubboEcho(@PathVariable("param") String param);

    @RequestMapping(value = "/config/test", method = RequestMethod.GET)
    String configTest();
}