package com.tsf.demo.dubbo.impl;

import com.tsf.demo.dubbo.service.MiddlemanDubboService;
import com.tsf.demo.dubbo.service.ProviderDubboService;
import com.tsf.demo.service.ProviderFeignService;
import org.apache.dubbo.config.annotation.DubboService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import static com.tsf.demo.controller.CommonUtils.getInet4Address;

@DubboService(version = "1.0")
public class MiddlemanDubboServiceImpl implements MiddlemanDubboService {
    private static final Logger LOG = LoggerFactory.getLogger(MiddlemanDubboServiceImpl.class);

    @Autowired
    ProviderDubboService providerDubboService;

    @Autowired
    ProviderFeignService providerFeignService;


    public String echo(String param) {
        LOG.info("middleman-dubbo -- request param: [" + param + "]");
        String result = "middleman received dubbo, from host-ip: " + getInet4Address() + ", param:" + param;
        LOG.info("middleman-dubbo -- response info: [" + result + "]");
        return result;
    }

    @Override
    public String dubbo2HttpEcho(String param) {
        LOG.info("middleman-dubbo -- request param: [" + param + "]");
        String result = "middleman received dubbo, " + providerFeignService.echo(param);
        LOG.info("middleman-dubbo -- response info: [" + result + "]");
        return result;
    }

    @Override
    public String dubbo2DubboEcho(String param) {
        LOG.info("middleman-dubbo -- request param: [" + param + "]");
        String result = "middleman received dubbo, " + providerDubboService.echo(param);
        LOG.info("middleman-dubbo -- response info: [" + result + "]");
        return result;
    }
}
