package com.tsf.demo.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

import static com.tsf.demo.controller.CommonUtils.getInet4Address;

@RestController
public class ProviderController {
    private static final Logger LOG = LoggerFactory.getLogger(ProviderController.class);

    @RequestMapping(value = "/echo/{param}", method = RequestMethod.GET)
    public String echo(@PathVariable String param, HttpServletResponse response) throws IOException {
        switch (param) {
            case "1xx":
                response.setStatus(HttpServletResponse.SC_CONTINUE);
                response.getWriter().write("mock 1xx return.");
                response.getWriter().flush();
                return "mock 1xx return.";
            case "3xx":
                response.setStatus(HttpServletResponse.SC_FOUND);
                response.getWriter().write("mock 3xx return.");
                response.getWriter().flush();
                return "mock 3xx return.";
            case "4xx":
                response.setStatus(HttpServletResponse.SC_NOT_FOUND);
                response.getWriter().write("mock 4xx return.");
                response.getWriter().flush();
                return "mock 4xx return.";
            case "5xx":
                response.setStatus(HttpServletResponse.SC_BAD_GATEWAY);
                response.getWriter().write("mock 5xx return.");
                response.getWriter().flush();
                return "mock 5xx return.";
            default:
                LOG.info("provider-http -- request param: [" + param + "]");
                String result = "provider received http, from host-ip: " + getInet4Address() + ",request param: " + param;
                LOG.info("provider-http -- response info: [" + result + "]");
                return result;
        }
    }
}